## emacs-list-utils 0.4.7

=== Makefile ===
EMACS=emacs
# EMACS=/Applications/Emacs.app/Contents/MacOS/Emacs
# EMACS=/Applications/Aquamacs.app/Contents/MacOS/Aquamacs
# EMACS=/Applications/Macmacs.app/Contents/MacOS/Emacs
# EMACS=/usr/local/bin/emacs
# EMACS=/opt/local/bin/emacs
# EMACS=/usr/bin/emacs

INTERACTIVE_EMACS=/usr/local/bin/emacs
# can't find an OS X variant that works correctly for interactive tests:
# INTERACTIVE_EMACS=open -a Emacs.app --new --args
# INTERACTIVE_EMACS=/Applications/Emacs.app/Contents/MacOS/Emacs
# INTERACTIVE_EMACS=/Applications/Emacs.app/Contents/MacOS/bin/emacs

EMACS_CLEAN=-Q
EMACS_BATCH=$(EMACS_CLEAN) --batch
# TESTS can be overridden to specify a subset of tests
TESTS=
WIKI_USERNAME=roland.walker

CURL=curl --location --silent
EDITOR=runemacs -no_wait
WORK_DIR=$(shell pwd)
PACKAGE_NAME=$(shell basename $(WORK_DIR))
PACKAGE_VERSION=$(shell perl -ne 'print "$$1\n" if m{^;+ *Version: *(\S+)}' $(PACKAGE_NAME).el)
AUTOLOADS_FILE=$(PACKAGE_NAME)-autoloads.el
TEST_DIR=ert-tests
TEST_DEP_1=ert
TEST_DEP_1_STABLE_URL=http://git.savannah.gnu.org/cgit/emacs.git/plain/lisp/emacs-lisp/ert.el?h=emacs-24.3
TEST_DEP_1_LATEST_URL=http://git.savannah.gnu.org/cgit/emacs.git/plain/lisp/emacs-lisp/ert.el?h=master

.PHONY : build dist not-dirty pkg-version downloads downloads-latest autoloads \
 test-autoloads test test-prep test-batch test-interactive                     \
 test-tests clean edit run-pristine run-pristine-local upload-github           \
 upload-wiki upload-marmalade test-dep-1 test-dep-2 test-dep-3 test-dep-4      \
 test-dep-5 test-dep-6 test-dep-7 test-dep-8 test-dep-9

build :
	$(EMACS) $(EMACS_BATCH) --eval    \
	    "(progn                                \
	      (batch-byte-compile))" *.el

not-dirty :
	@git diff --quiet '$(PACKAGE_NAME).el'     || \
	 ( git --no-pager diff '$(PACKAGE_NAME).el';  \
	   echo "Uncommitted edits - do a git stash"; \
	   false )

pkg-version :
	@test -n '$(PACKAGE_VERSION)'    || \
	 ( echo "No package version"; false )

test-dep-1 :
	@cd '$(TEST_DIR)'                                               && \
	$(EMACS) $(EMACS_BATCH)  -L . -L .. -l '$(TEST_DEP_1)' || \
	(echo "Can't load test dependency $(TEST_DEP_1).el, run 'make downloads' to fetch it" ; exit 1)

downloads :
	$(CURL) '$(TEST_DEP_1_STABLE_URL)' > '$(TEST_DIR)/$(TEST_DEP_1).el'

downloads-latest :
	$(CURL) '$(TEST_DEP_1_LATEST_URL)' > '$(TEST_DIR)/$(TEST_DEP_1).el'

autoloads :
	$(EMACS) $(EMACS_BATCH) --eval              \
	    "(progn                                          \
	      (setq generated-autoload-file \"$(WORK_DIR)/$(AUTOLOADS_FILE)\") \
	      (update-directory-autoloads \"$(WORK_DIR)\"))"

test-autoloads : autoloads
	@$(EMACS) $(EMACS_BATCH) -L . -l './$(AUTOLOADS_FILE)' || \
	 ( echo "failed to load autoloads: $(AUTOLOADS_FILE)" && false )

test-tests :
	@perl -ne 'if (m/^\s*\(\s*ert-deftest\s*(\S+)/) {die "$$1 test name duplicated in $$ARGV\n" if $$dupes{$$1}++}' '$(TEST_DIR)/'*-test.el

test-prep : build test-dep-1 test-autoloads test-tests

test-batch :
	@cd '$(TEST_DIR)'                                 && \
	(for test_lib in *-test.el; do                       \
	   $(EMACS) $(EMACS_BATCH) -L . -L .. -l cl-macs      \
	   -l '$(TEST_DEP_1)' -l "$$test_lib" --eval         \
	    "(progn                                          \
	      (fset 'ert--print-backtrace 'ignore)           \
	      (ert-run-tests-batch-and-exit '(and \"$(TESTS)\" (not (tag :interactive)))))" || exit 1; \
	done)

test-interactive : test-prep
	@cd '$(TEST_DIR)'                                             && \
	(for test_lib in *-test.el; do                                   \
	    $(INTERACTIVE_EMACS) $(EMACS_CLEAN) --eval          \
	    "(progn                                                      \
	      (cd \"$(WORK_DIR)/$(TEST_DIR)\")                           \
	      (setq dired-use-ls-dired nil)                              \
	      (setq frame-title-format \"TEST SESSION $$test_lib\")      \
	      (setq enable-local-variables :safe))"                      \
	    -L . -L .. -l cl-macs -l '$(TEST_DEP_1)' -l "$$test_lib"      \
	    --visit "$$test_lib" --eval                                  \
	    "(progn                                                      \
	      (when (> (length \"$(TESTS)\") 0)                          \
	       (push \"\\\"$(TESTS)\\\"\" ert--selector-history))        \
	      (setq buffer-read-only t)                                  \
	      (setq cursor-in-echo-area t)                               \
	      (call-interactively 'ert-run-tests-interactively)          \
	      (ding)                                                     \
	      (when (y-or-n-p \"PRESS Y TO QUIT THIS TEST SESSION\")     \
	       (with-current-buffer \"*ert*\"                            \
	        (kill-emacs                                              \
	         (if (re-search-forward \"^Failed:[^\\n]+unexpected\" 500 t) 1 0)))))" || exit 1; \
	done)

test : test-prep test-batch

run-pristine :
	@cd '$(TEST_DIR)'                                              && \
	$(EMACS) $(EMACS_CLEAN) --eval                           \
	 "(progn                                                          \
	   (setq package-enable-at-startup nil)                           \
	   (setq package-load-list nil)                                   \
	   (when (fboundp 'package-initialize)                            \
	    (package-initialize))                                         \
	   (cd \"$(WORK_DIR)/$(TEST_DIR)\")                               \
	   (setq dired-use-ls-dired nil)                                  \
	   (setq frame-title-format \"PRISTINE SESSION $(PACKAGE_NAME)\") \
	   (setq enable-local-variables :safe))"                          \
	 -L .. -l '$(PACKAGE_NAME)' .

run-pristine-local :
	@cd '$(TEST_DIR)'                                              && \
	$(EMACS) $(EMACS_CLEAN) --eval                           \
	 "(progn                                                          \
	   (cd \"$(WORK_DIR)/$(TEST_DIR)\")                               \
	   (setq dired-use-ls-dired nil)                                  \
	   (setq frame-title-format \"PRISTINE-LOCAL SESSION $(PACKAGE_NAME)\") \
	   (setq enable-local-variables :safe))"                          \
	 -L . -L .. -l '$(PACKAGE_NAME)' .

clean :
	@rm -f '$(AUTOLOADS_FILE)' *.elc *~ */*.elc */*~ .DS_Store */.DS_Store *.bak */*.bak && \
	cd '$(TEST_DIR)'                                                                     && \
	rm -f './$(TEST_DEP_1).el' './$(TEST_DEP_2).el' './$(TEST_DEP_3).el' './$(TEST_DEP_4).el' './$(TEST_DEP_5a).el' \
	      './$(TEST_DEP_5).el' './$(TEST_DEP_6).el' './$(TEST_DEP_7).el' './$(TEST_DEP_8).el' './$(TEST_DEP_9).el'

edit :
	@$(EDITOR) `git ls-files`

upload-github :
	@git push origin master

upload-wiki : not-dirty
	@$(EMACS) $(EMACS_BATCH) --eval          \
	 "(progn                                          \
	   (setq package-load-list '((yaoddmuse t)))      \
	   (when (fboundp 'package-initialize)            \
	    (package-initialize))                         \
	   (require 'yaoddmuse)                           \
	   (setq yaoddmuse-username \"$(WIKI_USERNAME)\") \
	   (yaoddmuse-post-file                           \
	    \"$(PACKAGE_NAME).el\"                        \
	    yaoddmuse-default-wiki                        \
	    \"$(PACKAGE_NAME).el\"                        \
	    \"updated version\") \
	   (sleep-for 5))"

=== debian/changelog ===
emacs-list-utils (0.4.7-1) unstable; urgency=medium

  * Initial release. (Closes: #1127601)

 -- Xiyue Deng <manphiz@gmail.com>  Tue, 10 Feb 2026 10:00:51 -0800

=== debian/control ===
Source: emacs-list-utils
Section: editors
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders: Xiyue Deng <manphiz@gmail.com>
Build-Depends: debhelper-compat (= 13),
 dh-elpa
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-list-utils
Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-list-utils.git
Homepage: https://github.com/rolandwalker/list-utils
Testsuite: autopkgtest-pkg-elpa

Package: elpa-list-utils
Architecture: all
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs
Enhances: emacs
Description: List-manipulation utility functions
 List-utils is a collection of functions for list manipulation. This
 library has no user-level interface; it is only useful for programming
 in Emacs Lisp.
 .
 Notable functionality includes
  * list-utils-flatten, a robust list-flattener which handles cyclic
    lists, non-nil-terminated lists, and preserves nils when they are
    found as list elements.
  * tconc, a simple data structure for efficiently appending to a list

=== debian/watch ===
Version: 5

Template: Github
Owner: rolandwalker
Project: list-utils
